This section introduces readers to OpenStack Networking (v2) API, provides guidelines on how to use it, and describes common features available to users throughout all Networking APIs.
The Networking API v2.0 is a RESTful HTTP service that uses all aspects of the
HTTP protocol including methods, URIs, media types, response codes, and so on.
Providers can use existing features of the protocol including caching,
persistent connections, and content compression. For example, providers who
employ a caching layer can respond with a 203 code instead of a 200 code
when a request is served from the cache. Additionally, providers can offer support
for conditional GET requests by using ETags, or they may send a redirect in
response to a GET request. Create clients so that these differences are
accounted for.
The Networking API v2.0 uses the OpenStack Identity service as the default authentication
service. When Keystone is enabled, users that submit requests to the OpenStack
Networking service must provide an authentication token in X-Auth-Token
request header. You obtain the token by authenticating to the Keystone
endpoint.
When Keystone is enabled, the project_id attribute is not required in create
requests because the project ID is derived from the authentication token.
NOTE: Currently the Networking API accepts the deprecated tenant_id
attribute for the project ID for backward compatibility.
The default authorization settings allow only administrative users to create resources on behalf of a different project.
OpenStack Networking uses information received from Keystone to authorize user requests. OpenStack Networking handles the following types of authorization policies:
The actual authorization policies enforced in OpenStack Networking might vary from deployment to deployment.
The Networking API v2.0 supports JSON data serialization request and response formats only.
The Networking API v2.0 only accepts requests with the JSON data serialization
format. The Content-Type header is ignored.
Starting with the Newton release of the Networking service, the Networking API
accepts the project_id attribute in addition to the tenant_id attribute
in requests. The tenant_id attribute is accepted for backward compatibility.
If both the project_id and the tenant_id attribute are provided in the
same request, their values must be identical.
To determine whether a Networking API v2.0 endpoint supports the project_id
attribute in requests, check that the project-id API extension is enabled
(see Extensions).
The Networking API v2.0 always responds with the JSON data serialization
format. The Accept header is ignored.
Query extension
A .json extension can be added to the request URI. For example, the
.json extension in the following requests are equivalent:
Starting with the Newton release of the Networking service, the Networking API
returns a project_id attribute in responses, while still returning a
tenant_id attribute for backward compatibility. The values will always be
identical.
To determine whether a Networking API v2.0 endpoint returns the project_id
attribute in responses, check that the project-id API extension is enabled
(see Extensions).
The Networking API v2.0 supports filtering based on all top level attributes of a resource. Filters are applicable to all list requests.
For example, the following request returns all networks named foobar:
GET /v2.0/networks?name=foobar
When you specify multiple filters using different fields, the Networking API v2.0 returns only objects that meet all filtering criteria. The operation applies an AND condition among different filter fields.
OpenStack Networking offers an OR mechanism for filters by repeating the field
with the different OR criteria. For example, to find all networks named
foobar OR bizbaz:
GET /v2.0/networks?name=foobar&name=bizbaz
ORs and ANDs can be combined. For example, if you want all networks with
admin_state_up=True and shared=True and named foobar or bizbaz:
GET /v2.0/networks?name=foobar&name=bizbaz&admin_state_up=True&shared=True
Starting from Rocky release, the Networking API might support filtering
attributes with empty value. For example, the request below lists all ports
that have device_id attribute with empty value (which are unbound ports).
GET /v2.0/networks?device_id=
To determine if this feature is supported, a user can check whether the
empty-string-filtering extension API is available.
Starting from Rocky release, the Networking API will perform validation
on filtering attributes if the API extension filter-validation is
available. If an API request contains an unknown or unsupported
parameter, the server will return a 400 response instead of silently
ignoring the invalid input.
By default, OpenStack Networking returns all attributes for any show or list
call. The Networking API v2.0 has a mechanism to limit the set of attributes
returned. For example, return id.
You can use the fields query parameter to control the attributes returned
from the Networking API v2.0.
For example, the following request returns only id and name for each
network:
GET /v2.0/networks.json?fields=id&fields=name
The Networking API v2.0 presents a logical model of network connectivity consisting of networks, ports, and subnets. It is up to the OpenStack Networking plug-in to communicate with the underlying infrastructure to ensure packet forwarding is consistent with the logical model. A plug-in might perform these operations asynchronously.
When an API client modifies the logical model by issuing an HTTP POST,
PUT, or DELETE request, the API call might return before the plug-in
modifies underlying virtual and physical switching devices. However, an API
client is guaranteed that all subsequent API calls properly reflect the changed
logical model.
For example, if a client issues an HTTP PUT request to set the attachment
for a port, there is no guarantee that packets sent by the interface named in
the attachment are forwarded immediately when the HTTP call returns. However,
it is guaranteed that a subsequent HTTP GET request to view the attachment
on that port returns the new attachment value.
You can use the status attribute with the network and port resources to
determine whether the OpenStack Networking plug-in has successfully completed
the configuration of the resource.
The Networking API v2.0 enables you to create several objects of the same type in the same API request. Bulk create operations use exactly the same API syntax as single create operations except that you specify a list of objects rather than a single object in the request body.
Bulk operations are always performed atomically, meaning that either all or none of the objects in the request body are created. If a particular plug-in does not support atomic operations, the Networking API v2.0 emulates the atomic behavior so that users can expect the same behavior regardless of the particular plug-in running in the background.
OpenStack Networking might be deployed without support for bulk operations and
when the client attempts a bulk create operation, a 400 Bad request error is
returned.
To reduce load on the service, list operations will return a maximum number of
items at a time. To navigate the collection, the parameters limit, marker
and page_reverse can be set in the URI. For example:
?limit=100&marker=1234&page_reverse=False
The marker parameter is the ID of the last item in the previous list. The
limit parameter sets the page size. The page_reverse parameter sets
the page direction. These parameters are optional. If the client requests a
limit beyond the maximum limit configured by the deployment, the server returns
the maximum limit number of items.
For convenience, list responses contain atom next links and previous
links. The last page in the list requested with page_reverse=False will not
contain next link, and the last page in the list requested with
page_reverse=True will not contain previous link. The following examples
illustrate two pages with three items. The first page was retrieved through:
GET http://127.0.0.1:9696/v2.0/networks.json?limit=2
Pagination is an optional feature of OpenStack Networking API, and it might be disabled. If pagination is disabled, the pagination parameters will be ignored and return all the items.
If a particular plug-in does not support pagination operations, and pagination is enabled, the Networking API v2.0 will emulate the pagination behavior so that users can expect the same behavior regardless of the particular plug-in running in the background.
To determine if pagination is supported, a user can check whether the ‘pagination’ extension API is available.
Example Network collection, first page: JSON request
GET /v2.0/networks.json?limit=2 HTTP/1.1
Host: 127.0.0.1:9696
Content-Type: application/json
Accept: application/json
Example Network collection, first page: JSON response
{
"networks": [
{
"admin_state_up": true,
"id": "396f12f8-521e-4b91-8e21-2e003500433a",
"name": "net3",
"provider:network_type": "vlan",
"provider:physical_network": "physnet1",
"provider:segmentation_id": 1002,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tenant_id": "20bd52ff3e1b40039c312395b04683cf"
"project_id": "20bd52ff3e1b40039c312395b04683cf"
},
{
"admin_state_up": true,
"id": "71c1e68c-171a-4aa2-aca5-50ea153a3718",
"name": "net2",
"provider:network_type": "vlan",
"provider:physical_network": "physnet1",
"provider:segmentation_id": 1001,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tenant_id": "20bd52ff3e1b40039c312395b04683cf"
"project_id": "20bd52ff3e1b40039c312395b04683cf"
}
],
"networks_links": [
{
"href": "http://127.0.0.1:9696/v2.0/networks.json?limit=2&marker=71c1e68c-171a-4aa2-aca5-50ea153a3718",
"rel": "next"
},
{
"href": "http://127.0.0.1:9696/v2.0/networks.json?limit=2&marker=396f12f8-521e-4b91-8e21-2e003500433a&page_reverse=True",
"rel": "previous"
}
]
}
The last page won’t show the next links
Example Network collection, last page: JSON request
GET /v2.0/networks.json?limit=2&marker=71c1e68c-171a-4aa2-aca5-50ea153a3718 HTTP/1.1
Host: 127.0.0.1:9696
Content-Type: application/json
Accept: application/json
Example Network collection, last page: JSON response
{
"networks": [
{
"admin_state_up": true,
"id": "b3680498-03da-4691-896f-ef9ee1d856a7",
"name": "net1",
"provider:network_type": "vlan",
"provider:physical_network": "physnet1",
"provider:segmentation_id": 1000,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tenant_id": "c05140b3dc7c4555afff9fab6b58edc2"
"project_id": "c05140b3dc7c4555afff9fab6b58edc2"
}
],
"networks_links": [
{
"href": "http://127.0.0.1:9696/v2.0/networks.json?limit=2&marker=b3680498-03da-4691-896f-ef9ee1d856a7&page_reverse=True",
"rel": "previous"
}
]
}
You can use the sort_key and sort_dir parameters to sort the
results of list operations. Currently sorting does not work with extended
attributes of resource. The sort_key and sort_dir can be repeated,
and the number of sort_key and sort_dir provided must be same. The
sort_dir parameter indicates in which direction to sort. Acceptable
values are asc (ascending) and desc (descending).
Sorting is optional feature of OpenStack Networking API, and it might be disabled. If sorting is disabled, the sorting parameters are ignored.
If a particular plug-in does not support sorting operations and sorting is enabled, the Networking API v2.0 emulates the sorting behavior so that users can expect the same behavior regardless of the particular plug-in that runs in the background.
To determine if sorting is supported, a user can check whether the ‘sorting’ extension API is available.
Starting from Rocky release, the Networking API performs validation on
sorting attributes if the API extension sort-key-validation is available.
If an API request contains an unknown or unsupported sort key,
the server will return a 400 response instead of silently ignoring
the invalid input.
The Networking API v2.0 is extensible.
The purpose of Networking API v2.0 extensions is to:
To programmatically determine which extensions are available, issue a GET
request on the v2.0/extensions URI.
To query extensions individually by unique alias, issue a GET request on
the /v2.0/extensions/*alias_name* URI. Use this method to easily
determine if an extension is available. If the extension is not available, a
404 Not Found response is returned.
You can extend existing core API resources with new actions or extra attributes. Also, you can add new resources as extensions. Extensions usually have tags that prevent conflicts with other extensions that define attributes or resources with the same names, and with core resources and attributes. Because an extension might not be supported by all plug-ins, the availability of an extension varies with deployments and the specific plug-in in use.
The Networking API v2.0 returns an error response if a failure occurs while
processing a request. OpenStack Networking uses only standard HTTP error codes.
4nn errors indicate problems in the particular request being sent from
the client.
| Error | Description |
|---|---|
400 |
Bad request Malformed request URI or body requested admin state invalid Invalid values entered Bulk operations disallowed Validation failed Method not allowed for request body (such as trying to update attributes that can be specified at create-time only) |
404 |
Not Found Non existent URI Resource not found |
409 |
Conflict Port configured on network IP allocated on subnet Conflicting IP allocation pools for subnet |
412 |
Precondition failed The revision number is mismatched |
500 |
Internal server error Internal OpenStack Networking error |
503 |
Service unavailable Failure in Mac address generation |
Users submitting requests to the Networking API v2.0 might also receive the following errors:
401 Unauthorized - If invalid credentials are provided.403 Forbidden - If the user cannot access a specific resource or perform
the requested operation.The Resource revision numbers extension (standard-attr-revisions) adds
the revision_number attribute to all API resources that support standard
attributes. This includes networks, ports, subnets, subnet pools, floating IPs,
routers, logs, security groups/rules, network segments, QoS policies and trunks.
As you’d expect, the revision_number indicates the number of updates a
particular resource has undergone and is read-only.
In addition, the If-Match constraints based on revision_number extension
(revision-if-match) allows API consumers to leverage the If-Match HTTP
header to conditionally update/delete a resource when the HTTP If-Match
header matches the revision_number of the said resource.
If the HTTP If-Match header doesn’t match the revision_number of the
resource, users will receive the following errors:
412 Precondition failed - Update/Delete the target resource has been
denied due to the mismatch of revision number.Lists information for all Networking API versions.
Lists information about all Networking API versions.
Normal response codes: 200
| Name | In | Type | Description |
|---|---|---|---|
| versions | body | array | List of versions. |
| status | body | string | Status of the API, which can be CURRENT, STABLE or DEPRECATED. |
| id | body | string | Version of the API. |
| links | body | array | List of version links. Each link is a dict with ‘href’ and ‘rel’. |
| href | body | string | Link to the API. |
| rel | body | string | Relationship of link with the version. |
{
"versions": [
{
"status": "CURRENT",
"id": "v2.0",
"links": [
{
"href": "http://23.253.228.211:9696/v2.0",
"rel": "self"
}
]
}
]
}
Shows details for Networking API v2.0.
Normal response codes: 200
Error response codes: 401
| Name | In | Type | Description |
|---|---|---|---|
| resources | body | array | List of resource objects. |
| name | body | string | Name of the resource. |
| collection | body | string | Collection name of the resource. |
| links | body | array | List of links related to the resource. Each link is a dict with ‘href’ and ‘rel’. |
| href | body | string | Link to the resource. |
| rel | body | string | Relationship between link and the resource. |
{
"resources": [
{
"links": [
{
"href": "http://23.253.228.211:9696/v2.0/subnets",
"rel": "self"
}
],
"name": "subnet",
"collection": "subnets"
},
{
"links": [
{
"href": "http://23.253.228.211:9696/v2.0/networks",
"rel": "self"
}
],
"name": "network",
"collection": "networks"
},
{
"links": [
{
"href": "http://23.253.228.211:9696/v2.0/ports",
"rel": "self"
}
],
"name": "port",
"collection": "ports"
}
]
}
Extensions introduce features and vendor-specific functionality to the API.
Lists available extensions.
Lists available Networking API v2.0 extensions and shows details for an extension.
Normal response codes: 200
Error response codes: 401
| Name | In | Type | Description |
|---|---|---|---|
| extensions | body | array | A list of extension objects. |
| name | body | string | Human-readable name of the resource. |
| links | body | array | List of links related to the extension. |
| alias | body | string | The alias for the extension. For example “quotas” or “security-group”. |
| updated | body | string | The date and timestamp when the extension was last updated. |
| description | body | string | The human-readable description for the resource. |
{
"extensions": [
{
"updated": "2013-01-20T00:00:00-00:00",
"name": "Neutron Service Type Management",
"links": [],
"alias": "service-type",
"description": "API for retrieving service providers for Neutron advanced services"
},
{
"updated": "2012-10-05T10:00:00-00:00",
"name": "security-group",
"links": [],
"alias": "security-group",
"description": "The security groups extension."
},
{
"updated": "2013-02-07T10:00:00-00:00",
"name": "L3 Agent Scheduler",
"links": [],
"alias": "l3_agent_scheduler",
"description": "Schedule routers among l3 agents"
},
{
"updated": "2013-02-07T10:00:00-00:00",
"name": "Loadbalancer Agent Scheduler",
"links": [],
"alias": "lbaas_agent_scheduler",
"description": "Schedule pools among lbaas agents"
},
{
"updated": "2013-03-28T10:00:00-00:00",
"name": "Neutron L3 Configurable external gateway mode",
"links": [],
"alias": "ext-gw-mode",
"description": "Extension of the router abstraction for specifying whether SNAT should occur on the external gateway"
},
{
"updated": "2014-02-03T10:00:00-00:00",
"name": "Port Binding",
"links": [],
"alias": "binding",
"description": "Expose port bindings of a virtual port to external application"
},
{
"updated": "2012-09-07T10:00:00-00:00",
"name": "Provider Network",
"links": [],
"alias": "provider",
"description": "Expose mapping of virtual networks to physical networks"
},
{
"updated": "2013-02-03T10:00:00-00:00",
"name": "agent",
"links": [],
"alias": "agent",
"description": "The agent management extension."
},
{
"updated": "2012-07-29T10:00:00-00:00",
"name": "Quota management support",
"links": [],
"alias": "quotas",
"description": "Expose functions for quotas management per tenant"
},
{
"updated": "2013-02-07T10:00:00-00:00",
"name": "DHCP Agent Scheduler",
"links": [],
"alias": "dhcp_agent_scheduler",
"description": "Schedule networks among dhcp agents"
},
{
"updated": "2013-06-27T10:00:00-00:00",
"name": "Multi Provider Network",
"links": [],
"alias": "multi-provider",
"description": "Expose mapping of virtual networks to multiple physical networks"
},
{
"updated": "2013-01-14T10:00:00-00:00",
"name": "Neutron external network",
"links": [],
"alias": "external-net",
"description": "Adds external network attribute to network resource."
},
{
"updated": "2012-07-20T10:00:00-00:00",
"name": "Neutron L3 Router",
"links": [],
"alias": "router",
"description": "Router abstraction for basic L3 forwarding between L2 Neutron networks and access to external networks via a NAT gateway."
},
{
"updated": "2013-07-23T10:00:00-00:00",
"name": "Allowed Address Pairs",
"links": [],
"alias": "allowed-address-pairs",
"description": "Provides allowed address pairs"
},
{
"updated": "2013-03-17T12:00:00-00:00",
"name": "Neutron Extra DHCP opts",
"links": [],
"alias": "extra_dhcp_opt",
"description": "Extra options configuration for DHCP. For example PXE boot options to DHCP clients can be specified (e.g. tftp-server, server-ip-address, bootfile-name)"
},
{
"updated": "2012-10-07T10:00:00-00:00",
"name": "LoadBalancing service",
"links": [],
"alias": "lbaas",
"description": "Extension for LoadBalancing service"
},
{
"updated": "2013-02-01T10:00:00-00:00",
"name": "Neutron Extra Route",
"links": [],
"alias": "extraroute",
"description": "Extra routes configuration for L3 router"
},
{
"updated": "2016-01-24T10:00:00-00:00",
"name": "Neutron Port Data Plane Status",
"links": [],
"alias": "data-plane-status",
"description": "Status of the underlying data plane."
}
]
}
Shows details for an extension, by alias. The response shows the extension name and its alias. To show details for an extension, you specify the alias.
Normal response codes: 200
Error response codes: 401, 404
| Name | In | Type | Description |
|---|---|---|---|
| alias | path | string | The alias of an extension. |
| Name | In | Type | Description |
|---|---|---|---|
| extension | body | object | An extension object. |
| name | body | string | Human-readable name of the resource. |
| links | body | array | List of links related to the extension. |
| alias | body | string | The alias for the extension. For example “quotas” or “security-group”. |
| updated | body | string | The date and timestamp when the extension was last updated. |
| description | body | string | The human-readable description for the resource. |
{
"extension": {
"updated": "2013-02-03T10:00:00-00:00",
"name": "agent",
"links": [],
"alias": "agent",
"description": "The agent management extension."
}
}
Lists, shows details for, creates, updates, and deletes networks.
The address-scope extension adds the ipv4_address_scope and
ipv6_address_scope attributes to networks. ipv4_address_scope
is the ID of the IPv4 address scope that the network is associated with.
ipv6_address_scope is the ID of the IPv6 address scope that the network
is associated with.
The auto-allocated-topology extension adds the is_default boolean
attribute to networks. This value indicates the network should be used when
auto allocating topologies.
The dns-integration extension adds the dns_domain attribute to networks.
The dns_domain of a network in conjunction with the dns_name attribute
of its ports will be published in an external DNS service when Neutron is
configured to integrate with such a service.
The external-net extension adds the router:external attribute to
networks. This boolean attribute indicates the network has an external
routing facility that’s not managed by the networking service.
The l2_adjacency extension provides display of L2 Adjacency
for networks by adding the read-only l2_adjacency attribute.
This is a boolean value where true means that you can expect
L2 connectivity throughout the Network and false means that there
is no guarantee of L2 connectivity.
This value is read-only and is derived from the current state of
segments within the network.
The net-mtu extension allows plug-ins to expose the MTU that is guaranteed
to pass through the data path of the segments in the network. This extension
introduces a read-only mtu attribute.
A newer net-mtu-writable extension enhances net-mtu in that now the
mtu attribute is available for write (both when creating as well as
updating networks).
The multi-provider extension allows administrative users to define multiple
physical bindings for a logical network.
To define multiple physical bindings for a network, include a segments list
in the request body of network creation request. Each element in the
segments list has the same structure as the provider network
attributes. These attributes are provider:network_type,
provider:physical_network, and provider:segmentation_id. The same
validation rules are applied to each element in the segments list.
Note that you cannot use the provider extension and the multiple provider extension for a single logical network.
The network_availability_zone extension provides support of availability
zone for networks, exposing availability_zone_hints
and availability_zones attributes.
The port-security extension adds the port_security_enabled boolean
attribute to networks. At the network level, port_security_enabled
defines the default value for new ports attached to the network; they will
inherit the value of their network’s port_security_enabled unless
explicitly set on the port itself. While the default value for
port_security_enabled is true, this can be changed by updating the
respective network. Note that changing a value of port_security_enabled
on a network, does not cascade the value to ports attached to the network.
The provider extension allows administrative users to define a physical
binding of a logical network. This extension provides three additional
attributes: provider:network_type, provider:physical_network and
provider:segmentation_id. The validation rules for these attributes
vary across provider:network_type. For example, vlan and flat
network types require provider:physical_network attribute, but vxlan
network type does not.
Most Networking plug-ins (e.g. ML2 Plugin) and drivers do not support updating any provider related attributes. Check your plug-in whether it supports updating.
The QoS extension (qos) makes it possible to
define QoS policies and associate these to the networks by introducing the
qos_policy_id attribute. The policies should be created before they are
associated to the networks.
The standard-attr-timestamp extension adds the created_at and
updated_at attributes to all resources that have standard attributes.
The standard-attr-tag adds Tag support for resources with
standard attributes by adding the tags attribute
allowing consumers to associate tags with resources.
The vlan-transparent extension enables plug-ins that support VLAN
transparency to deliver VLAN transparent trunk networks.
This extension introduces a vlan_transparent attribute to control
the VLAN transparency of the network. If the service does not support VLAN
transparency and a user requests a VLAN transparent network,
the plug-in refuses to create one and returns an appropriate error to the user.
Shows details for a network.
Use the fields query parameter to control which fields are
returned in the response body. For information, see Filtering and
Column Selection.
Normal response codes: 200
Error response codes: 401, 404
| Name | In | Type | Description |
|---|---|---|---|
| network_id | path | string | The ID of the network. |
| fields (Optional) | query | string | The fields that you want the server to return.
If no fields query parameter is specified,
the networking API returns all attributes allowed by the policy settings.
By using fields parameter, the API returns only the requested set of
attributes. fields parameter can be specified multiple times.
For example, if you specify fields=id&fields=name in the request URL,
only id and name attributes will be returned. |
| Name | In | Type | Description |
|---|---|---|---|
| network | body | object | A network object. |
| admin_state_up | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| availability_zone_hints | body | array | The availability zone candidate for the network. |
| availability_zones | body | array | The availability zone for the network. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| dns_domain | body | string | A valid DNS domain. |
| id | body | string | The ID of the network. |
| ipv4_address_scope | body | string | The ID of the IPv4 address scope that the network is associated with. |
| ipv6_address_scope | body | string | The ID of the IPv6 address scope that the network is associated with. |
| l2_adjacency | body | boolean | Indicates whether L2 connectivity is available throughout
the network. |
| mtu | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name | body | string | Human-readable name of the network. |
| port_security_enabled | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id | body | string | The ID of the project. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the network. |
| revision_number | body | integer | The revision number of the resource. |
| router:external | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared | body | boolean | Indicates whether this network is shared across all tenants. By default, only administrative users can change this value. |
| status | body | string | The network status. Values are ACTIVE, DOWN, BUILD or ERROR. |
| subnets | body | array | The associated subnets. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| vlan_transparent | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description | body | string | A human-readable description for the resource. |
| is_default | body | boolean | The network is default pool or not. |
| tags | body | array | The list of tags on the resource. |
{
"network": {
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "d32019d3-bc6e-4319-9c1d-6722fc136a22",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "private-network",
"port_security_enabled": true,
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": true,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": true
}
}
{
"network": {
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "d32019d3-bc6e-4319-9c1d-6722fc136a22",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "private-network",
"port_security_enabled": true,
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"provider:network_type": "local",
"provider:physical_network": null,
"provider:segmentation_id": null,
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": true,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": true
}
}
{
"network": {
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "4e8e5957-649f-477b-9e5b-f1f75b21c03c",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "net1",
"port_security_enabled": true,
"project_id": "9bacb3c5d39d41a79512987f338cf177",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"segments": [
{
"provider:network_type": "vlan",
"provider:physical_network": "public",
"provider:segmentation_id": 2
},
{
"provider:network_type": "flat",
"provider:physical_network": "default",
"provider:segmentation_id": 0
}
],
"shared": false,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": false
}
}
Updates a network.
Normal response codes: 200
Error response codes: 400, 401, 403, 404, 412
| Name | In | Type | Description |
|---|---|---|---|
| network_id | path | string | The ID of the network. |
| network | body | object | A network object. |
| admin_state_up (Optional) | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| dns_domain (Optional) | body | string | A valid DNS domain. |
| mtu (Optional) | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name (Optional) | body | string | Human-readable name of the network. |
| port_security_enabled (Optional) | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id (Optional) | body | string | The ID of the QoS policy associated with the network. |
| router:external (Optional) | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared (Optional) | body | boolean | Indicates whether this resource is shared across all projects. By default, only administrative users can change this value. |
| description (Optional) | body | string | A human-readable description for the resource. Default is an empty string. |
| is_default (Optional) | body | boolean | The network is default or not. |
{
"network": {
"dns_domain": "my-domain.org.",
"name": "sample_network_5_updated",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"mtu": 1300
}
}
{
"network": {
"provider:network_type": "vlan",
"provider:physical_network": "public",
"provider:segmentation_id": 2
}
}
{
"network": {
"segments": [
{
"provider:segmentation_id": 2,
"provider:physical_network": "public",
"provider:network_type": "vlan"
},
{
"provider:physical_network": "default",
"provider:network_type": "flat"
}
]
}
}
| Name | In | Type | Description |
|---|---|---|---|
| network | body | object | A network object. |
| admin_state_up | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| availability_zone_hints | body | array | The availability zone candidate for the network. |
| availability_zones | body | array | The availability zone for the network. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| dns_domain | body | string | A valid DNS domain. |
| id | body | string | The ID of the network. |
| ipv4_address_scope | body | string | The ID of the IPv4 address scope that the network is associated with. |
| ipv6_address_scope | body | string | The ID of the IPv6 address scope that the network is associated with. |
| l2_adjacency | body | boolean | Indicates whether L2 connectivity is available throughout
the network. |
| mtu | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name | body | string | Human-readable name of the network. |
| port_security_enabled | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id | body | string | The ID of the project. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the network. |
| revision_number | body | integer | The revision number of the resource. |
| router:external | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared | body | boolean | Indicates whether this network is shared across all tenants. By default, only administrative users can change this value. |
| status | body | string | The network status. Values are ACTIVE, DOWN, BUILD or ERROR. |
| subnets | body | array | The associated subnets. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| description | body | string | A human-readable description for the resource. |
| is_default | body | boolean | The network is default pool or not. |
| tags | body | array | The list of tags on the resource. |
This is an example when a regular user without administrative roles sends a PUT request. Response examples for administrative users are similar to responses of Show network details and Create network. See them for details.
{
"network": {
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "1f370095-98f6-4079-be64-6d3d4a6adcc6",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1300,
"name": "sample_network_5_updated",
"port_security_enabled": true,
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 2,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": false
}
}
Deletes a network and its associated resources.
Normal response codes: 204
Error response codes: 401, 404, 409, 412
| Name | In | Type | Description |
|---|---|---|---|
| network_id | path | string | The ID of the network. |
There is no body content for the response of a successful DELETE request.
Lists networks to which the project has access.
Default policy settings return only networks that the project who submits the request owns, unless an administrative user submits the request. In addition, networks shared with the project who submits the request are also returned.
Use the fields query parameter to control which fields are
returned in the response body. Additionally, you can filter results
by using query string parameters. For information, see Filtering
and Column Selection.
You can also use the tags, tags-any, not-tags, not-tags-any
query parameter to filter the response with tags. For information,
see REST API Impact.
Normal response codes: 200
Error response codes: 401
| Name | In | Type | Description |
|---|---|---|---|
| admin_state_up (Optional) | query | boolean | Filter the list result by the administrative state of the resource,
which is up (true) or down (false). |
| id (Optional) | query | string | Filter the list result by the ID of the resource. |
| mtu (Optional) | query | integer | Filter the network list result by the maximum transmission unit (MTU)
value to address fragmentation. Minimum value is 68 for IPv4,
and 1280 for IPv6. |
| name (Optional) | query | string | Filter the list result by the human-readable name of the resource. |
| project_id (Optional) | query | string | Filter the list result by the ID of the project that owns the resource. |
| provider:network_type (Optional) | query | string | Filter the list result by the type of physical network that this
network/segment is mapped to. For example, flat, vlan, vxlan,
or gre. Valid values depend on a networking back-end. |
| provider:physical_network (Optional) | query | string | Filter the list result by the physical network where this network/segment is implemented. |
| provider:segmentation_id (Optional) | query | integer | Filter the list result by the ID of the isolated segment on the physical network. |
| revision_number (Optional) | query | integer | Filter the list result by the revision number of the resource. |
| router:external (Optional) | query | boolean | Filter the network list result based on whether the network has an external routing facility that’s not managed by the networking service. |
| shared (Optional) | query | boolean | Filter the network list result based on if the network is shared across all tenants. |
| status (Optional) | query | string | Filter the network list result by network status. Values are ACTIVE,
DOWN, BUILD or ERROR. |
| tenant_id (Optional) | query | string | Filter the list result by the ID of the project that owns the resource. |
| vlan_transparent (Optional) | query | boolean | Filter the network list by the VLAN transparency mode of the network,
which is VLAN transparent (true) or not VLAN transparent (false). |
| description (Optional) | query | string | Filter the list result by the human-readable description of the resource. |
| is_default (Optional) | query | boolean | Filter the network list result based on if the network is default pool or not. |
| tags (Optional) | query | string | A list of tags to filter the list result by. Resources that match all tags in this list will be returned. Tags in query must be separated by comma. |
| tags-any (Optional) | query | string | A list of tags to filter the list result by. Resources that match any tag in this list will be returned. Tags in query must be separated by comma. |
| not-tags (Optional) | query | string | A list of tags to filter the list result by. Resources that match all tags in this list will be excluded. Tags in query must be separated by comma. |
| not-tags-any (Optional) | query | string | A list of tags to filter the list result by. Resources that match any tag in this list will be excluded. Tags in query must be separated by comma. |
| sort_dir (Optional) | query | string | Sort direction. A valid value is asc (ascending) or desc
(descending). You can specify multiple pairs of sort key and
sort direction query parameters. |
| sort_key (Optional) | query | string | Sorts by a network attribute. You can specify multiple pairs of sort key and sort direction query parameters. The sort keys are limited to:
|
| fields (Optional) | query | string | The fields that you want the server to return.
If no fields query parameter is specified,
the networking API returns all attributes allowed by the policy settings.
By using fields parameter, the API returns only the requested set of
attributes. fields parameter can be specified multiple times.
For example, if you specify fields=id&fields=name in the request URL,
only id and name attributes will be returned. |
| Name | In | Type | Description |
|---|---|---|---|
| networks | body | array | A list of network objects. |
| admin_state_up | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| availability_zone_hints | body | array | The availability zone candidate for the network. |
| availability_zones | body | array | The availability zone for the network. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| dns_domain | body | string | A valid DNS domain. |
| id | body | string | The ID of the network. |
| ipv4_address_scope | body | string | The ID of the IPv4 address scope that the network is associated with. |
| ipv6_address_scope | body | string | The ID of the IPv6 address scope that the network is associated with. |
| l2_adjacency | body | boolean | Indicates whether L2 connectivity is available throughout
the network. |
| mtu | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name | body | string | Human-readable name of the network. |
| port_security_enabled | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id | body | string | The ID of the project. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the network. |
| revision_number | body | integer | The revision number of the resource. |
| router:external | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared | body | boolean | Indicates whether this network is shared across all tenants. By default, only administrative users can change this value. |
| status | body | string | The network status. Values are ACTIVE, DOWN, BUILD or ERROR. |
| subnets | body | array | The associated subnets. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| vlan_transparent | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description | body | string | A human-readable description for the resource. |
| is_default | body | boolean | The network is default pool or not. |
| tags | body | array | The list of tags on the resource. |
{
"networks": [
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "d32019d3-bc6e-4319-9c1d-6722fc136a22",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "net1",
"port_security_enabled": true,
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": true,
"description": "",
"is_default": false
},
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "db193ab3-96e3-4cb3-8fc5-05f4296d0324",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "net2",
"port_security_enabled": true,
"project_id": "26a7980765d0414dbc1fc1f88cdb7e6e",
"qos_policy_id": "bfdb6c39f71e4d44b1dfbda245c50819",
"revision_number": 3,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [
"08eae331-0402-425a-923c-34f7cfe39c1b"
],
"tenant_id": "26a7980765d0414dbc1fc1f88cdb7e6e",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": false
}
]
}
When Administrative users request to list networks,
physical segment information bound to the networks are also returned
in a response. In this example, a network net1 is mapped to a single
network segment and a network net2 is mapped to multiple network segments.
{
"networks": [
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "d32019d3-bc6e-4319-9c1d-6722fc136a22",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1500,
"name": "net1",
"port_security_enabled": true,
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"provider:network_type": "vlan",
"provider:physical_network": "public",
"provider:segmentation_id": 3,
"revision_number": 1,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [
"54d6f61d-db07-451c-9ab3-b9609b6b6f0b"
],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": true,
"description": "",
"is_default": false
},
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "db193ab3-96e3-4cb3-8fc5-05f4296d0324",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": false,
"mtu": 1450,
"name": "net2",
"port_security_enabled": true,
"project_id": "26a7980765d0414dbc1fc1f88cdb7e6e",
"qos_policy_id": null,
"provider:network_type": "local",
"provider:physical_network": null,
"provider:segmentation_id": null,
"qos_policy_id": "bfdb6c39f71e4d44b1dfbda245c50819",
"revision_number": 2,
"router:external": false,
"segments": [
{
"provider:network_type": "vlan",
"provider:physical_network": "public",
"provider:segmentation_id": 2
},
{
"provider:network_type": "vxlan",
"provider:physical_network": "default",
"provider:segmentation_id": 1000
}
],
"shared": false,
"status": "ACTIVE",
"subnets": [
"08eae331-0402-425a-923c-34f7cfe39c1b"
],
"tags": ["tag1,tag2"],
"tenant_id": "26a7980765d0414dbc1fc1f88cdb7e6e",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": false
}
]
}
Creates a network.
A request body is optional. An administrative user can specify another project ID, which is the project that owns the network, in the request body.
Normal response codes: 201
Error response codes: 400, 401
| Name | In | Type | Description |
|---|---|---|---|
| network | body | object | A network object. |
| admin_state_up (Optional) | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| dns_domain (Optional) | body | string | A valid DNS domain. |
| mtu (Optional) | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name (Optional) | body | string | Human-readable name of the network. |
| port_security_enabled (Optional) | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id (Optional) | body | string | The ID of the project that owns the resource. Only administrative and users with advsvc role can specify a project ID other than their own. You cannot change this value through authorization policies. |
| provider:network_type (Optional) | body | string | The type of physical network that this network should be mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network (Optional) | body | string | The physical network where this network should be implemented. The Networking API v2.0 does not provide a way to list available physical networks. For example, the Open vSwitch plug-in configuration file defines a symbolic name that maps to specific bridges on each compute host. |
| provider:segmentation_id (Optional) | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id (Optional) | body | string | The ID of the QoS policy associated with the network. |
| router:external (Optional) | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments (Optional) | body | array | A list of provider segment objects. |
| shared (Optional) | body | boolean | Indicates whether this resource is shared across all projects. By default, only administrative users can change this value. |
| tenant_id (Optional) | body | string | The ID of the project that owns the resource. Only administrative and users with advsvc role can specify a project ID other than their own. You cannot change this value through authorization policies. |
| vlan_transparent (Optional) | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description (Optional) | body | string | A human-readable description for the resource. Default is an empty string. |
| is_default (Optional) | body | boolean | The network is default or not. |
| availability_zone_hints (Optional) | body | array | The availability zone candidate for the network. |
{
"network": {
"name": "sample_network",
"admin_state_up": true,
"dns_domain": "my-domain.org.",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"mtu": 1400
}
}
{
"network": {
"admin_state_up": true,
"name": "net1",
"provider:network_type": "vlan",
"provider:physical_network": "public",
"provider:segmentation_id": 2,
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e"
}
}
{
"network": {
"segments": [
{
"provider:segmentation_id": 2,
"provider:physical_network": "public",
"provider:network_type": "vlan"
},
{
"provider:physical_network": "default",
"provider:network_type": "flat"
}
],
"name": "net1",
"admin_state_up": true,
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e"
}
}
| Name | In | Type | Description |
|---|---|---|---|
| network | body | object | A network object. |
| admin_state_up | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| availability_zone_hints | body | array | The availability zone candidate for the network. |
| availability_zones | body | array | The availability zone for the network. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| dns_domain | body | string | A valid DNS domain. |
| id | body | string | The ID of the network. |
| ipv4_address_scope | body | string | The ID of the IPv4 address scope that the network is associated with. |
| ipv6_address_scope | body | string | The ID of the IPv6 address scope that the network is associated with. |
| l2_adjacency | body | boolean | Indicates whether L2 connectivity is available throughout
the network. |
| mtu | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name | body | string | Human-readable name of the network. |
| port_security_enabled | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id | body | string | The ID of the project. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the network. |
| revision_number | body | integer | The revision number of the resource. |
| router:external | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared | body | boolean | Indicates whether this network is shared across all tenants. By default, only administrative users can change this value. |
| status | body | string | The network status. Values are ACTIVE, DOWN, BUILD or ERROR. |
| subnets | body | array | The associated subnets. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| vlan_transparent | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description | body | string | A human-readable description for the resource. |
| is_default | body | boolean | The network is default pool or not. |
| tags | body | array | The list of tags on the resource. |
{
"network": {
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "my-domain.org.",
"id": "4e8e5957-649f-477b-9e5b-f1f75b21c03c",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": true,
"mtu": 1400,
"name": "net1",
"port_security_enabled": true,
"project_id": "9bacb3c5d39d41a79512987f338cf177",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tags": ["tag1,tag2"],
"tenant_id": "9bacb3c5d39d41a79512987f338cf177",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"is_default": false
}
}
{
"network": {
"status": "ACTIVE",
"subnets": [],
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"name": "net1",
"provider:physical_network": "public",
"admin_state_up": true,
"project_id": "9bacb3c5d39d41a79512987f338cf177",
"tags": ["tag1,tag2"],
"tenant_id": "9bacb3c5d39d41a79512987f338cf177",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"provider:network_type": "vlan",
"l2_adjacency": true,
"mtu": 1500,
"shared": false,
"id": "4e8e5957-649f-477b-9e5b-f1f75b21c03c",
"provider:segmentation_id": 2,
"description": "",
"port_security_enabled": true,
"is_default": false
}
}
{
"network": {
"status": "ACTIVE",
"subnets": [],
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"name": "net1",
"admin_state_up": true,
"dns_domain": "",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": true,
"mtu": 1500,
"port_security_enabled": true,
"project_id": "9bacb3c5d39d41a79512987f338cf177",
"tags": ["tag1,tag2"],
"tenant_id": "9bacb3c5d39d41a79512987f338cf177",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"segments": [
{
"provider:segmentation_id": 2,
"provider:physical_network": "public",
"provider:network_type": "vlan"
},
{
"provider:segmentation_id": null,
"provider:physical_network": "default",
"provider:network_type": "flat"
}
],
"shared": false,
"id": "4e8e5957-649f-477b-9e5b-f1f75b21c03c",
"description": "",
"is_default": false
}
}
Creates multiple networks in a single request.
In the request body, specify a list of networks.
The bulk create operation is always atomic. Either all or no networks in the request body are created.
Normal response codes: 201
Error response codes: 400, 401
| Name | In | Type | Description |
|---|---|---|---|
| networks | body | array | A list of network objects. |
| admin_state_up (Optional) | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| dns_domain (Optional) | body | string | A valid DNS domain. |
| mtu (Optional) | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name (Optional) | body | string | Human-readable name of the network. |
| port_security_enabled (Optional) | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id (Optional) | body | string | The ID of the project that owns the resource. Only administrative and users with advsvc role can specify a project ID other than their own. You cannot change this value through authorization policies. |
| provider:network_type (Optional) | body | string | The type of physical network that this network should be mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network (Optional) | body | string | The physical network where this network should be implemented. The Networking API v2.0 does not provide a way to list available physical networks. For example, the Open vSwitch plug-in configuration file defines a symbolic name that maps to specific bridges on each compute host. |
| provider:segmentation_id (Optional) | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id (Optional) | body | string | The ID of the QoS policy associated with the network. |
| router:external (Optional) | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments (Optional) | body | array | A list of provider segment objects. |
| shared (Optional) | body | boolean | Indicates whether this resource is shared across all projects. By default, only administrative users can change this value. |
| tenant_id (Optional) | body | string | The ID of the project that owns the resource. Only administrative and users with advsvc role can specify a project ID other than their own. You cannot change this value through authorization policies. |
| vlan_transparent (Optional) | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description (Optional) | body | string | A human-readable description for the resource. Default is an empty string. |
| availability_zone_hints (Optional) | body | array | The availability zone candidate for the network. |
{
"networks": [
{
"admin_state_up": true,
"name": "sample_network3",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e"
},
{
"admin_state_up": true,
"name": "sample_network4",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e"
}
]
}
| Name | In | Type | Description |
|---|---|---|---|
| networks | body | array | A list of network objects. |
| admin_state_up | body | boolean | The administrative state of the network, which is
up (true) or down (false). |
| availability_zone_hints | body | array | The availability zone candidate for the network. |
| availability_zones | body | array | The availability zone for the network. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| dns_domain | body | string | A valid DNS domain. |
| id | body | string | The ID of the network. |
| ipv4_address_scope | body | string | The ID of the IPv4 address scope that the network is associated with. |
| ipv6_address_scope | body | string | The ID of the IPv6 address scope that the network is associated with. |
| l2_adjacency | body | boolean | Indicates whether L2 connectivity is available throughout
the network. |
| mtu | body | integer | The maximum transmission unit (MTU) value to address fragmentation. Minimum value is 68 for IPv4, and 1280 for IPv6. |
| name | body | string | Human-readable name of the network. |
| port_security_enabled | body | boolean | The port security status of the network. Valid values are
enabled (true) and disabled (false).
This value is used as the default value of port_security_enabled
field of a newly created port. |
| project_id | body | string | The ID of the project. |
| provider:network_type | body | string | The type of physical network that this network is mapped to.
For example, flat, vlan, vxlan, or gre.
Valid values depend on a networking back-end. |
| provider:physical_network | body | string | The physical network where this network/segment is implemented. |
| provider:segmentation_id | body | integer | The ID of the isolated segment on the physical network.
The network_type attribute defines the segmentation model.
For example, if the network_type value is vlan, this ID is a vlan
identifier. If the network_type value is gre, this ID is a gre key. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the network. |
| revision_number | body | integer | The revision number of the resource. |
| router:external | body | boolean | Indicates whether the network has an external routing facility that’s not managed by the networking service. |
| segments | body | array | A list of provider segment objects. |
| shared | body | boolean | Indicates whether this network is shared across all tenants. By default, only administrative users can change this value. |
| status | body | string | The network status. Values are ACTIVE, DOWN, BUILD or ERROR. |
| subnets | body | array | The associated subnets. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| vlan_transparent | body | boolean | Indicates the VLAN transparency mode of the network, which is
VLAN transparent (true) or not VLAN transparent (false). |
| description | body | string | A human-readable description for the resource. |
| is_default | body | boolean | The network is default pool or not. |
| tags | body | array | The list of tags on the resource. |
{
"networks": [
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "",
"id": "bc1a76cb-8767-4c3a-bb95-018b822f2130",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": true,
"mtu": 1500,
"name": "sample_network3",
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"port_security_enabled": true,
"is_default": false
},
{
"admin_state_up": true,
"availability_zone_hints": [],
"availability_zones": [
"nova"
],
"created_at": "2016-03-08T20:19:41",
"dns_domain": "",
"id": "af374017-c9ae-4a1d-b799-ab73111476e2",
"ipv4_address_scope": null,
"ipv6_address_scope": null,
"l2_adjacency": true,
"mtu": 1500,
"name": "sample_network4",
"project_id": "4fd44f30292945e481c7b8a0c8908869",
"qos_policy_id": "6a8454ade84346f59e8d40665f878b2e",
"revision_number": 1,
"router:external": false,
"shared": false,
"status": "ACTIVE",
"subnets": [],
"tags": ["tag1,tag2"],
"tenant_id": "4fd44f30292945e481c7b8a0c8908869",
"updated_at": "2016-03-08T20:19:41",
"vlan_transparent": false,
"description": "",
"port_security_enabled": true,
"is_default": false
}
]
}
Lists, shows details for, creates, updates, and deletes ports.
The allowed-address-pairs extension adds an allowed_address_pairs
attribute to ports. The value of allowed_address_pairs is an array of
allowed address pair objects, each having an ip_address and a
mac_address. The set of allowed address pairs defines IP and MAC address
that the port can use when sending packets if port_security_enabled is
true (see the port-security extension). Note that while the
ip_address is required in each allowed address pair, the mac_address
is optional and will be taken from the port if not specified.
The data plane port extension (data-plane-status) adds a new attribute
data_plane_status to represent the status of the underlying data plane.
This attribute is to be managed by entities outside of the Networking service,
while the status attribute is managed by Networking service. Both status
attributes are independent from one another.
Supported data plane status values:
null: no status being reported; default valueACTIVE: the underlying data plane is up and runningDOWN: no traffic can flow from/to the portThe dns-integration extension adds the dns_name and dns_assignment
attributes to port resources. While the dns_name can be set on create and
update operations, the dns_assignment is read-only and shows the
hostname, ip_address and fqdn for the port’s internal DNS
assignment.
To enable the dns_domain on port resources, the dns-domain-ports
extension must be used in conjunction with the dns-integration extension.
When enabled and set, a port level dns_domain take precedence over a
dns_domain specified in the port’s network allowing per-port DNS domains.
extra_dhcp_opt) extension¶The extra DHCP option (extra_dhcp_opt) extension enables extra
DHCP configuration options on ports. For example, PXE boot
options to DHCP clients can be specified (e.g. tftp-server, server-ip-address,
bootfile-name). The value of the extra_dhcp_opt attribute is an array of
DHCP option objects, where each object contains an opt_name and
opt_value (string values) as well as an optional ip_version
(the acceptable values are either the integer 4 or 6).
The IP allocation extension (ip_allocation) adds a new read-only attribute
ip_allocation that indicates when ports use deferred, immediate or
no IP allocation.
The ip-substring-filtering extension adds support for filtering ports by
using part of an IP address.
The port binding extension (binding) allows administrative users
to specify and retrieve physical binding information of ports.
The extension defines several attributes whose names have a prefix
binding: including binding:host_id, binding:vnic_type,
binding:vif_type, binding:vif_details, and binding:profile.
The port resource request extension (port-resource-request) allows
administrative users (including Nova) to retrieve the Placement resources and
traits needed by a port by introducing the resource_request to port resources.
The port-security extension adds the port_security_enabled boolean
attribute to ports. If a port-security value is not specified during
port creation, a port will inherit the port_security_enabled from the
network its connected to.
The QoS extension (qos) makes it possible to
define QoS policies and associate these to the ports by introducing the
qos_policy_id attribute. The policies should be created before they are
associated to the ports.
The Port MAC address regenerate extension (port-mac-address-regenerate)
makes it possible to regenerate the mac address of a port. When passing
'null' (None) as the mac_address on port update, a new mac address
will be generated and set on the port.
The standard-attr-timestamp extension adds the created_at and
updated_at attributes to all resources that have standard attributes.
The standard-attr-tag adds Tag support for resources with
standard attributes by adding the tags attribute
allowing consumers to associate tags with resources.
The mac_learning_enabled extension extends neutron ports providing the
ability to enable MAC learning on the associated port via the
`mac_learning_enabled` attribute.
Shows details for a port.
Use the fields query parameter to control which fields are
returned in the response body. For information, see Filtering and
Column Selection.
Normal response codes: 200
Error response codes: 401, 404
| Name | In | Type | Description |
|---|---|---|---|
| port_id | path | string | The ID of the port. |
| fields (Optional) | query | string | The fields that you want the server to return.
If no fields query parameter is specified,
the networking API returns all attributes allowed by the policy settings.
By using fields parameter, the API returns only the requested set of
attributes. fields parameter can be specified multiple times.
For example, if you specify fields=id&fields=name in the request URL,
only id and name attributes will be returned. |
| Name | In | Type | Description |
|---|---|---|---|
| port | body | object | A port object. |
| admin_state_up | body | boolean | The administrative state of the resource, which is
up (true) or down (false). |
| allowed_address_pairs | body | array | A set of zero or more allowed address pair objects each where address pair
object contains an ip_address and mac_address. While the
ip_address is required, the mac_address will be taken from the
port if not specified. The value of ip_address can be an IP Address
or a CIDR (if supported by the underlying extension plugin).
A server connected to the port can send a packet with source address which
matches one of the specified allowed address pairs. |
| binding:host_id | body | string | The ID of the host where the port resides. |
| binding:profile | body | object | A dictionary that enables the application running on the specific host to pass and receive vif port information specific to the networking back-end. The networking API does not define a specific format of this field. |
| binding:vif_details | body | object | A dictionary which contains additional information on the port.
Currently the following fields are defined: port_filter and
ovs_hybrid_plug.
port_filter is a boolean indicating the networking service
provides port filtering features such as security group and/or
anti MAC/IP spoofing.
ovs_hybrid_plug is a boolean used to inform an API consumer
like nova that the hybrid plugging strategy for OVS should be used. |
| binding:vif_type | body | string | The type of which mechanism is used for the port.
An API consumer like nova can use this to determine an appropriate way to
attach a device (for example an interface of a virtual server) to the port.
Available values currently defined includes
ovs, bridge, macvtap, hw_veb, hostdev_physical,
vhostuser, distributed and other.
There are also special values: unbound and binding_failed.
unbound means the port is
not bound to a networking back-end. binding_failed means an error
that the port failed to be bound to a networking back-end. |
| binding:vnic_type | body | string | The type of vNIC which this port should be attached to. This is used to
determine which mechanism driver(s) to be used to bind the port.
The valid values are normal, macvtap, direct, baremetal,
direct-physical and virtio-forwarder.
What type of vNIC is actually available depends on deployments. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| data_plane_status | body | string | Status of the underlying data plane of a port. |
| description | body | string | A human-readable description for the resource. |
| device_id | body | string | The ID of the device that uses this port. For example, a server instance or a logical router. |
| device_owner | body | string | The entity type that uses this port.
For example, compute:nova (server instance), network:dhcp
(DHCP agent) or network:router_interface (router interface). |
| dns_assignment | body | object | Data assigned to a port by the Networking internal DNS including the
hostname, ip_address and fqdn. |
| dns_domain | body | string | A valid DNS domain. |
| dns_name | body | string | A valid DNS name. |
| extra_dhcp_opts | body | array | A set of zero or more extra DHCP option pairs. An option pair consists of an option value and name. |
| fixed_ips | body | array | The IP addresses for the port. If the port has multiple IP addresses,
this field has multiple entries. Each entry consists of IP address
(ip_address) and the subnet ID from which the IP address
is assigned (subnet_id). |
| id | body | string | The ID of the resource. |
| ip_allocation | body | string | Indicates when ports use either deferred, immediate or no IP
allocation (none). |
| mac_address | body | string | The MAC address of the port. |
| name | body | string | Human-readable name of the resource. |
| network_id | body | string | The ID of the attached network. |
| port_security_enabled | body | boolean | The port security status. A valid value is
enabled (true) or disabled (false).
If port security is enabled for the port,
security group rules and anti-spoofing rules are applied to
the traffic on the port. If disabled, no such rules are applied. |
| project_id | body | string | The ID of the project. |
| revision_number | body | integer | The revision number of the resource. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the port. |
| resource_request (Optional) | body | object | Expose Placement resources (i.e.: minimum-bandwidth) and
traits (i.e.: vnic-type, physnet) requested by a port to
Nova and Placement. A resource_request object contains a
required key for the traits (generated from the vnic_type
and the physnet) required by the port, and a resources key
for ingress and egress minimum-bandwidth need for the port. |
| security_groups | body | array | The IDs of security groups applied to the port. |
| status | body | string | The port status. Values are ACTIVE, DOWN,
BUILD and ERROR. |
| tags | body | array | The list of tags on the resource. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| mac_learning_enabled (Optional) | body | boolean | A boolean value that indicates if MAC Learning is enabled on the associated port. |
{
"port": {
"admin_state_up": true,
"allowed_address_pairs": [],
"created_at": "2016-03-08T20:19:41",
"data_plane_status": "ACTIVE",
"description": "",
"device_id": "5e3898d7-11be-483e-9732-b2f5eccd2b2e",
"device_owner": "network:router_interface",
"dns_assignment": {
"hostname": "myport",
"ip_address": "10.0.0.1",
"fqdn": "myport.my-domain.org"
},
"dns_domain": "my-domain.org.",
"dns_name": "myport",
"extra_dhcp_opts": [
{
"opt_value": "pxelinux.0",
"ip_version": 4,
"opt_name": "bootfile-name"
}
],
"fixed_ips": [
{
"ip_address": "10.0.0.1",
"subnet_id": "a0304c3a-4f08-4c43-88af-d796509c97d2"
}
],
"id": "46d4bfb9-b26e-41f3-bd2e-e6dcc1ccedb2",
"ip_allocation": "immediate",
"mac_address": "fa:16:3e:23:fd:d7",
"name": "",
"network_id": "a87cc70a-3e15-4acf-8205-9b711a3531b7",
"port_security_enabled": false,
"project_id": "7e02058126cc4950b75f9970368ba177",
"revision_number": 1,
"security_groups": [],
"status": "ACTIVE",
"tags": ["tag1,tag2"],
"tenant_id": "7e02058126cc4950b75f9970368ba177",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae"
}
}
{
"port": {
"admin_state_up": true,
"allowed_address_pairs": [],
"binding:host_id": "devstack",
"binding:profile": {},
"binding:vif_details": {
"ovs_hybrid_plug": true,
"port_filter": true
},
"binding:vif_type": "ovs",
"binding:vnic_type": "normal",
"created_at": "2016-03-08T20:19:41",
"data_plane_status": "ACTIVE",
"description": "",
"device_id": "5e3898d7-11be-483e-9732-b2f5eccd2b2e",
"device_owner": "network:router_interface",
"dns_assignment": {
"hostname": "myport",
"ip_address": "10.0.0.1",
"fqdn": "myport.my-domain.org"
},
"dns_domain": "my-domain.org.",
"dns_name": "myport",
"extra_dhcp_opts": [
{
"opt_value": "pxelinux.0",
"ip_version": 4,
"opt_name": "bootfile-name"
}
],
"fixed_ips": [
{
"ip_address": "10.0.0.1",
"subnet_id": "a0304c3a-4f08-4c43-88af-d796509c97d2"
}
],
"id": "46d4bfb9-b26e-41f3-bd2e-e6dcc1ccedb2",
"ip_allocation": "immediate",
"mac_address": "fa:16:3e:23:fd:d7",
"mac_learning_enabled": false,
"name": "",
"network_id": "a87cc70a-3e15-4acf-8205-9b711a3531b7",
"port_security_enabled": false,
"project_id": "7e02058126cc4950b75f9970368ba177",
"revision_number": 1,
"security_groups": [],
"status": "ACTIVE",
"tags": ["tag1,tag2"],
"tenant_id": "7e02058126cc4950b75f9970368ba177",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae",
"resource_request": {
"required": ["CUSTOM_PHYSNET_PUBLIC", "CUSTOM_VNIC_TYPE_NORMAL"],
"resources": {"NET_BANDWIDTH_EGRESS_KILOBITS_PER_SECOND": 1000}
}
}
}
Updates a port.
You can update information for a port, such as its symbolic name
and associated IPs. When you update IPs for a port, any previously
associated IPs are removed, returned to the respective subnet
allocation pools, and replaced by the IPs in the request body.
Therefore, this operation replaces the fixed_ip attribute when
you specify it in the request body. If the updated IP addresses are
not valid or are already in use, the operation fails and the
existing IP addresses are not removed from the port.
When you update security groups for a port and the operation
succeeds, any associated security groups are removed and replaced
by the security groups in the request body. Therefore, this
operation replaces the security_groups attribute when you
specify it in the request body. If the security groups are not
valid, the operation fails and the existing security groups are not
removed from the port.
Only admins and users with a specific role can update the data plane status
(default role: data_plane_integrator).
Normal response codes: 200
Error response codes: 400, 401, 403, 404, 409, 412
| Name | In | Type | Description |
|---|---|---|---|
| port_id | path | string | The ID of the port. |
| port | body | object | A port object. |
| admin_state_up (Optional) | body | boolean | The administrative state of the resource, which is
up (true) or down (false).
Default is true. |
| allowed_address_pairs (Optional) | body | array | A set of zero or more allowed address pair objects each where address pair
object contains an ip_address and mac_address. While the
ip_address is required, the mac_address will be taken from the
port if not specified. The value of ip_address can be an IP Address
or a CIDR (if supported by the underlying extension plugin).
A server connected to the port can send a packet with source address which
matches one of the specified allowed address pairs. |
| binding:host_id (Optional) | body | string | The ID of the host where the port resides. The default is an empty string. |
| binding:profile (Optional) | body | object | A dictionary that enables the application running on the specific host to pass and receive vif port information specific to the networking back-end. The networking API does not define a specific format of this field. The default is an empty dictionary. |
| binding:vnic_type (Optional) | body | string | The type of vNIC which this port should be attached to. This is used to
determine which mechanism driver(s) to be used to bind the port.
The valid values are normal, macvtap, direct, baremetal,
direct-physical and virtio-forwarder.
What type of vNIC is actually available depends on deployments.
The default is normal. |
| data_plane_status (Optional) | body | string | Status of the underlying data plane of a port. |
| description (Optional) | body | string | A human-readable description for the resource. Default is an empty string. |
| device_id (Optional) | body | string | The ID of the device that uses this port. For example, a server instance or a logical router. |
| device_owner (Optional) | body | string | The entity type that uses this port.
For example, compute:nova (server instance), network:dhcp
(DHCP agent) or network:router_interface (router interface). |
| dns_domain (Optional) | body | string | A valid DNS domain. |
| dns_name (Optional) | body | string | A valid DNS name. |
| extra_dhcp_opts (Optional) | body | array | A set of zero or more extra DHCP option pairs. An option pair consists of an option value and name. |
| fixed_ips (Optional) | body | array | The IP addresses for the port.
If you would like to assign multiple IP addresses for the port,
specify multiple entries in this field.
Each entry consists of IP address (
|
| mac_address (Optional) | body | string | The MAC address of the port. By default, only administrative users and users with advsvc role can change this value. |
| name (Optional) | body | string | Human-readable name of the resource. Default is an empty string. |
| port_security_enabled (Optional) | body | boolean | The port security status. A valid value is
enabled (true) or disabled (false).
If port security is enabled for the port,
security group rules and anti-spoofing rules are applied to
the traffic on the port. If disabled, no such rules are applied. |
| qos_policy_id (Optional) | body | string | QoS policy associated with the port. |
| security_groups (Optional) | body | array | The IDs of security groups applied to the port. |
| mac_learning_enabled (Optional) | body | boolean | A boolean value that indicates if MAC Learning is enabled on the associated port. |
{
"port": {
"admin_state_up": true,
"device_id": "d90a13da-be41-461f-9f99-1dbcf438fdf2",
"device_owner": "compute:nova",
"name": "test-for-port-update",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae"
}
}
{
"port": {
"binding:host_id": "test_for_port_update_host",
"device_id": "d90a13da-be41-461f-9f99-1dbcf438fdf2",
"data_plane_status": "DOWN",
"device_owner": "compute:nova",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae"
}
}
| Name | In | Type | Description |
|---|---|---|---|
| port | body | object | A port object. |
| admin_state_up | body | boolean | The administrative state of the resource, which is
up (true) or down (false). |
| allowed_address_pairs | body | array | A set of zero or more allowed address pair objects each where address pair
object contains an ip_address and mac_address. While the
ip_address is required, the mac_address will be taken from the
port if not specified. The value of ip_address can be an IP Address
or a CIDR (if supported by the underlying extension plugin).
A server connected to the port can send a packet with source address which
matches one of the specified allowed address pairs. |
| binding:host_id | body | string | The ID of the host where the port resides. |
| binding:profile | body | object | A dictionary that enables the application running on the specific host to pass and receive vif port information specific to the networking back-end. The networking API does not define a specific format of this field. |
| binding:vif_details | body | object | A dictionary which contains additional information on the port.
Currently the following fields are defined: port_filter and
ovs_hybrid_plug.
port_filter is a boolean indicating the networking service
provides port filtering features such as security group and/or
anti MAC/IP spoofing.
ovs_hybrid_plug is a boolean used to inform an API consumer
like nova that the hybrid plugging strategy for OVS should be used. |
| binding:vif_type | body | string | The type of which mechanism is used for the port.
An API consumer like nova can use this to determine an appropriate way to
attach a device (for example an interface of a virtual server) to the port.
Available values currently defined includes
ovs, bridge, macvtap, hw_veb, hostdev_physical,
vhostuser, distributed and other.
There are also special values: unbound and binding_failed.
unbound means the port is
not bound to a networking back-end. binding_failed means an error
that the port failed to be bound to a networking back-end. |
| binding:vnic_type | body | string | The type of vNIC which this port should be attached to. This is used to
determine which mechanism driver(s) to be used to bind the port.
The valid values are normal, macvtap, direct, baremetal,
direct-physical and virtio-forwarder.
What type of vNIC is actually available depends on deployments. |
| created_at | body | string | Time at which the resource has been created (in UTC ISO8601 format). |
| data_plane_status | body | string | Status of the underlying data plane of a port. |
| description | body | string | A human-readable description for the resource. |
| device_id | body | string | The ID of the device that uses this port. For example, a server instance or a logical router. |
| device_owner | body | string | The entity type that uses this port.
For example, compute:nova (server instance), network:dhcp
(DHCP agent) or network:router_interface (router interface). |
| dns_assignment | body | object | Data assigned to a port by the Networking internal DNS including the
hostname, ip_address and fqdn. |
| dns_domain | body | string | A valid DNS domain. |
| dns_name | body | string | A valid DNS name. |
| extra_dhcp_opts | body | array | A set of zero or more extra DHCP option pairs. An option pair consists of an option value and name. |
| fixed_ips | body | array | The IP addresses for the port. If the port has multiple IP addresses,
this field has multiple entries. Each entry consists of IP address
(ip_address) and the subnet ID from which the IP address
is assigned (subnet_id). |
| id | body | string | The ID of the resource. |
| ip_allocation | body | string | Indicates when ports use either deferred, immediate or no IP
allocation (none). |
| mac_address | body | string | The MAC address of the port. |
| name | body | string | Human-readable name of the resource. |
| network_id | body | string | The ID of the attached network. |
| port_security_enabled | body | boolean | The port security status. A valid value is
enabled (true) or disabled (false).
If port security is enabled for the port,
security group rules and anti-spoofing rules are applied to
the traffic on the port. If disabled, no such rules are applied. |
| project_id | body | string | The ID of the project. |
| revision_number | body | integer | The revision number of the resource. |
| qos_policy_id | body | string | The ID of the QoS policy associated with the port. |
| resource_request (Optional) | body | object | Expose Placement resources (i.e.: minimum-bandwidth) and
traits (i.e.: vnic-type, physnet) requested by a port to
Nova and Placement. A resource_request object contains a
required key for the traits (generated from the vnic_type
and the physnet) required by the port, and a resources key
for ingress and egress minimum-bandwidth need for the port. |
| security_groups | body | array | The IDs of security groups applied to the port. |
| status | body | string | The port status. Values are ACTIVE, DOWN,
BUILD and ERROR. |
| tags | body | array | The list of tags on the resource. |
| tenant_id | body | string | The ID of the project. |
| updated_at | body | string | Time at which the resource has been updated (in UTC ISO8601 format). |
| mac_learning_enabled (Optional) | body | boolean | A boolean value that indicates if MAC Learning is enabled on the associated port. |
{
"port": {
"admin_state_up": true,
"allowed_address_pairs": [],
"binding:host_id": "test_for_port_update_host",
"binding:profile": {},
"binding:vif_details": {},
"binding:vif_type": "binding_failed",
"binding:vnic_type": "normal",
"created_at": "2016-03-08T20:19:41",
"data_plane_status": "ACTIVE",
"description": "",
"device_id": "d90a13da-be41-461f-9f99-1dbcf438fdf2",
"device_owner": "compute:nova",
"dns_assignment": {
"hostname": "myport",
"ip_address": "20.20.0.4",
"fqdn": "myport.my-domain.org"
},
"dns_domain": "my-domain.org.",
"dns_name": "myport",
"extra_dhcp_opts": [
{
"opt_value": "pxelinux.0",
"ip_version": 4,
"opt_name": "bootfile-name"
}
],
"fixed_ips": [
{
"ip_address": "20.20.0.4",
"subnet_id": "898dec4a-74df-4193-985f-c76721bcc746"
}
],
"id": "43c831e0-19ce-4a76-9a49-57b57e69428b",
"ip_allocation": "immediate",
"mac_address": "fa:16:3e:11:11:5e",
"name": "test-for-port-update",
"network_id": "883fc383-5ea1-4c8b-8916-e1ddb0a9f365",
"project_id": "522eda8d23124b25bf03fe44f1986b74",
"revision_number": 1,
"security_groups": [
"ce0179d6-8a94-4f7c-91c2-f3038e2acbd0"
],
"status": "DOWN",
"tags": ["tag1,tag2"],
"tenant_id": "522eda8d23124b25bf03fe44f1986b74",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae",
"port_security_enabled": false
}
}
{
"port": {
"admin_state_up": true,
"allowed_address_pairs": [],
"binding:host_id": "test_for_port_update_host",
"binding:profile": {},
"binding:vif_details": {},
"binding:vif_type": "binding_failed",
"binding:vnic_type": "normal",
"created_at": "2016-03-08T20:19:41",
"data_plane_status": "DOWN",
"description": "",
"device_id": "d90a13da-be41-461f-9f99-1dbcf438fdf2",
"device_owner": "compute:nova",
"dns_assignment": {
"hostname": "myport",
"ip_address": "20.20.0.4",
"fqdn": "myport.my-domain.org"
},
"dns_domain": "my-domain.org.",
"dns_name": "myport",
"extra_dhcp_opts": [
{
"opt_value": "pxelinux.0",
"ip_version": 4,
"opt_name": "bootfile-name"
}
],
"fixed_ips": [
{
"ip_address": "20.20.0.4",
"subnet_id": "898dec4a-74df-4193-985f-c76721bcc746"
}
],
"id": "43c831e0-19ce-4a76-9a49-57b57e69428b",
"ip_allocation": "immediate",
"mac_address": "fa:16:3e:11:11:5e",
"name": "test-for-port-update",
"network_id": "883fc383-5ea1-4c8b-8916-e1ddb0a9f365",
"project_id": "522eda8d23124b25bf03fe44f1986b74",
"revision_number": 2,
"security_groups": [
"ce0179d6-8a94-4f7c-91c2-f3038e2acbd0"
],
"status": "DOWN",
"tags": ["tag1,tag2"],
"tenant_id": "522eda8d23124b25bf03fe44f1986b74",
"updated_at": "2016-03-08T20:19:41",
"qos_policy_id": "29d5e02e-d5ab-4929-bee4-4a9fc12e22ae",
"port_security_enabled": false,
"resource_request": {
"required": ["CUSTOM_PHYSNET_PUBLIC", "CUSTOM_VNIC_TYPE_NORMAL"],
"resources": {"NET_BANDWIDTH_EGRESS_KILOBITS_PER_SECOND": 1000}
}
}
}
Deletes a port.
Any IP addresses that are associated with the port are returned to the respective subnets allocation pools.
Normal response codes: 204
Error response codes: 401, 403, 404, 412
| Name | In | Type | Description |
|---|---|---|---|
| port_id | path | string | The ID of the port. |
There is no body content for the response of a successful DELETE request.
Lists ports to which the user has access.
Default policy settings return only those ports that are owned by the project of the user who submits the request, unless the request is submitted by a user with administrative rights.
Use the fields query parameter to control which fields are
returned in the response body. Additionally, you can filter results
by using query string parameters. For information, see Filtering
and Column Selection.
If the ip-substring-filtering extension is enabled, the Neutron API
supports IP address substring filtering on the fixed_ips attribute.
If you specify an IP address substring (ip_address_substr) in
an entry of the fixed_ips attribute, the Neutron API will list all
ports that have an IP address matching the substring.
Normal response codes: 200
Error response codes: 401
| Name | In | Type | Description |
|---|---|---|---|
| admin_state_up (Optional) | query | boolean | Filter the list result by the administrative state of the resource,
which is up (true) or down (false). |
| binding:host_id (Optional) | query | string | Filter the port list result by the ID of the host where the port resides. |
| description (Optional) | query | string | Filter the list result by the human-readable description of the resource. |
| device_id (Optional) | query | string | Filter the port list result by the ID of the device that uses this port. For example, a server instance or a logical router. |
| device_owner (Optional) | query | string | Filter the port result list by the entity type that uses this port.
For example, compute:nova (server instance), network:dhcp
(DHCP agent) or network:router_interface (router interface). |
| fixed_ips (Optional) | query | array | Filter the port list result by the IP addresses for the port.
This field has one or multiple entries.
Each entry consists of IP address (ip_address), IP address substring
(ip_address_substr) and/or the subnet ID from which
the IP address is assigned (subnet_id). |
| id (Optional) | query | string | Filter the list result by the ID of the resource. |
| ip_allocation (Optional) | query | string | Filter the port list result based on if the ports use deferred,
immediate or no IP allocation (none). |
| mac_address (Optional) | query | string | Filter the port list result by the MAC address of the port. |
| name (Optional) | query | string | Filter the list result by the human-readable name of the resource. |
| network_id (Optional) | query | string | Filter the list result by the ID of the attached network. |
| project_id (Optional) | query | string | Filter the list result by the ID of the project that owns the resource. |
| revision_number (Optional) | query | integer | Filter the list result by the revision number of the resource. |
| sort_dir (Optional) | query | string | Sort direction. A valid value is asc (ascending) or desc
(descending). You can specify multiple pairs of sort key and
sort direction query parameters. |
| sort_key (Optional) | query | string | Sorts by a port attribute. You can specify multiple pairs of sort key and sort direction query parameters. The sort keys are limited to:
|
| status (Optional) | query | string | Filter the port list result by the port status.
Values are ACTIVE, DOWN, BUILD and ERROR. |
| tenant_id (Optional) | query | string | Filter the list result by the ID of the project that owns the resource. |
| tags (Optional) | query | string | A list of tags to filter the list result by. Resources that match all tags in this list will be returned. Tags in query must be separated by comma. |
| tags-any (Optional) | query | string | A list of tags to filter the list result by. Resources that match any tag in this list will be returned. Tags in query must be separated by comma. |
[...]
